package net.pricefx.common.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import net.pricefx.common.api.PublishingTemplateInputType;

import java.util.ArrayList;
import java.util.List;

@JsonIgnoreProperties(ignoreUnknown=true)
public class PublishingTemplatesDTO {

	@JsonIgnoreProperties(ignoreUnknown=true)
	public static class PublishingTemplateDTO {
		private String name;
		private String id;
		private boolean isDefault;
		private boolean isConvertibleToPdf;
		private boolean isConvertibleToInputType = true;
		private String preprocessingLogicName;
		private PublishingTemplateInputType templateInputType;
		private boolean isToSign;

		//json deserialization relies on this one
		public PublishingTemplateDTO() {}

		public PublishingTemplateDTO(String name, String id, boolean isDefault, PublishingTemplateInputType templateInputType) {
			this.name = name;
			this.id = id;
			this.isDefault = isDefault;
			this.templateInputType = templateInputType;
		}

		public String getName() {
			return name;
		}

		public void setName(String name) {
			this.name = name;
		}

		public String getId() {
			return id;
		}

		public void setId(String id) {
			this.id = id;
		}

		public boolean getIsDefault() {
			return isDefault;
		}

		public void setIsDefault(boolean aDefault) {
			this.isDefault = aDefault;
		}

		public boolean getIsConvertibleToPdf() {
			return isConvertibleToPdf;
		}

		public void setIsConvertibleToPdf(boolean convertibleToPdf) {
			isConvertibleToPdf = convertibleToPdf;
		}
		
		public boolean getIsToSign() {
			return isToSign;
		}
		
		public void setIsToSign(boolean toSign) {
			isToSign = toSign;
		}
		
		public String getPreprocessingLogicName() {
			return preprocessingLogicName;
		}

		public void setPreprocessingLogicName(String preprocessingLogicName) {
			this.preprocessingLogicName = preprocessingLogicName;
		}

		public PublishingTemplateInputType getTemplateInputType() {
			return templateInputType;
		}

		public void setTemplateInputType(PublishingTemplateInputType templateInputType) {
			this.templateInputType = templateInputType;
		}

		public boolean getIsConvertibleToInputType() {
			return isConvertibleToInputType;
		}

		public void setIsConvertibleToInputType(boolean convertibleToInputType) {
			isConvertibleToInputType = convertibleToInputType;
		}
	}

	private List<PublishingTemplateDTO> templates = new ArrayList<>();

	public List<PublishingTemplateDTO> getTemplates() {
		return templates;
	}

	public void setTemplates(List<PublishingTemplateDTO> templates) {
		this.templates = templates;
	}
}
